# Do not edit this file; it's autogenerated.

load common


@test 'custom build chtest' {
    scope standard
    TARBALL=$TARDIR/chtest.tar.gz
    PQ=$TARDIR/chtest.pq_missing
    WORKDIR=$TARDIR/chtest.tmp
    rm -f "$PQ"
    mkdir "$WORKDIR"
    cd "chtest"
    run ./Build "$PWD" "$TARBALL" "$WORKDIR"
    echo "$output"
    rm -Rf "$WORKDIR"
    if [[ $status -eq 65 ]]; then
         touch "$PQ"
         skip 'prerequisites not met'
    fi
    [[ $status -eq 0 ]]
}

@test 'custom build missing' {
    scope quick
    TARBALL=$TARDIR/missing.tar.gz
    PQ=$TARDIR/missing.pq_missing
    WORKDIR=$TARDIR/missing.tmp
    rm -f "$PQ"
    mkdir "$WORKDIR"
    cd "."
    run ./Build.missing "$PWD" "$TARBALL" "$WORKDIR"
    echo "$output"
    rm -Rf "$WORKDIR"
    if [[ $status -eq 65 ]]; then
         touch "$PQ"
         skip 'prerequisites not met'
    fi
    [[ $status -eq 0 ]]
}

@test 'ch-build alpine36' {
    scope quick
    need_docker alpine36
    ch-build -t alpine36 --file="Dockerfile.alpine36" ..
    sudo docker tag alpine36 "alpine36:$CH_VERSION_DOCKER"
    docker_ok alpine36
}
@test 'ch-docker2tar alpine36' {
    scope quick
    need_docker
    TARBALL="$TARDIR/alpine36.tar.gz"
    ch-docker2tar alpine36 "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build alpineedge' {
    scope full
    need_docker alpineedge
    ch-build -t alpineedge --file="Dockerfile.alpineedge" ..
    sudo docker tag alpineedge "alpineedge:$CH_VERSION_DOCKER"
    docker_ok alpineedge
}
@test 'ch-docker2tar alpineedge' {
    scope full
    need_docker
    TARBALL="$TARDIR/alpineedge.tar.gz"
    ch-docker2tar alpineedge "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build centos6' {
    scope full
    need_docker centos6
    ch-build -t centos6 --file="Dockerfile.centos6" ..
    sudo docker tag centos6 "centos6:$CH_VERSION_DOCKER"
    docker_ok centos6
}
@test 'ch-docker2tar centos6' {
    scope full
    need_docker
    TARBALL="$TARDIR/centos6.tar.gz"
    ch-docker2tar centos6 "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build centos7' {
    scope full
    need_docker centos7
    ch-build -t centos7 --file="Dockerfile.centos7" ..
    sudo docker tag centos7 "centos7:$CH_VERSION_DOCKER"
    docker_ok centos7
}
@test 'ch-docker2tar centos7' {
    scope full
    need_docker
    TARBALL="$TARDIR/centos7.tar.gz"
    ch-docker2tar centos7 "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build debian9' {
    scope standard
    need_docker debian9
    ch-build -t debian9 --file="Dockerfile.debian9" ..
    sudo docker tag debian9 "debian9:$CH_VERSION_DOCKER"
    docker_ok debian9
}
@test 'ch-docker2tar debian9' {
    scope standard
    need_docker
    TARBALL="$TARDIR/debian9.tar.gz"
    ch-docker2tar debian9 "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build mpich' {
    scope full
    need_docker mpich
    ch-build -t mpich --file="Dockerfile.mpich" ..
    sudo docker tag mpich "mpich:$CH_VERSION_DOCKER"
    docker_ok mpich
}
@test 'ch-docker2tar mpich' {
    scope full
    need_docker
    TARBALL="$TARDIR/mpich.tar.gz"
    ch-docker2tar mpich "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build nvidia' {
    scope full
    need_docker nvidia
    ch-build -t nvidia --file="Dockerfile.nvidia" ..
    sudo docker tag nvidia "nvidia:$CH_VERSION_DOCKER"
    docker_ok nvidia
}
@test 'ch-docker2tar nvidia' {
    scope full
    need_docker
    TARBALL="$TARDIR/nvidia.tar.gz"
    ch-docker2tar nvidia "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build openmpi' {
    scope full
    need_docker openmpi
    ch-build -t openmpi --file="Dockerfile.openmpi" ..
    sudo docker tag openmpi "openmpi:$CH_VERSION_DOCKER"
    docker_ok openmpi
}
@test 'ch-docker2tar openmpi' {
    scope full
    need_docker
    TARBALL="$TARDIR/openmpi.tar.gz"
    ch-docker2tar openmpi "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build python3' {
    scope full
    need_docker python3
    ch-build -t python3 --file="Dockerfile.python3" ..
    sudo docker tag python3 "python3:$CH_VERSION_DOCKER"
    docker_ok python3
}
@test 'ch-docker2tar python3' {
    scope full
    need_docker
    TARBALL="$TARDIR/python3.tar.gz"
    ch-docker2tar python3 "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build ubuntu1604' {
    scope full
    need_docker ubuntu1604
    ch-build -t ubuntu1604 --file="Dockerfile.ubuntu1604" ..
    sudo docker tag ubuntu1604 "ubuntu1604:$CH_VERSION_DOCKER"
    docker_ok ubuntu1604
}
@test 'ch-docker2tar ubuntu1604' {
    scope full
    need_docker
    TARBALL="$TARDIR/ubuntu1604.tar.gz"
    ch-docker2tar ubuntu1604 "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'docker pull alpine36_dp' {
    scope quick
    need_docker alpine36_dp
    sudo docker pull alpine:3.6
    sudo docker tag alpine:3.6 alpine36_dp
    sudo docker tag alpine36_dp "alpine36_dp:$CH_VERSION_DOCKER"
    docker_ok alpine36_dp
}
@test 'ch-docker2tar alpine36_dp' {
    scope quick
    need_docker
    TARBALL="$TARDIR/alpine36_dp.tar.gz"
    ch-docker2tar alpine36_dp "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build lammps' {
    scope full
    need_docker lammps
    ch-build -t lammps --file="../examples/mpi/lammps/Dockerfile" ..
    sudo docker tag lammps "lammps:$CH_VERSION_DOCKER"
    docker_ok lammps
}
@test 'ch-docker2tar lammps' {
    scope full
    need_docker
    TARBALL="$TARDIR/lammps.tar.gz"
    ch-docker2tar lammps "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build mpibench-mpich' {
    scope full
    need_docker mpibench-mpich
    ch-build -t mpibench-mpich --file="../examples/mpi/mpibench-mpich/Dockerfile" ..
    sudo docker tag mpibench-mpich "mpibench-mpich:$CH_VERSION_DOCKER"
    docker_ok mpibench-mpich
}
@test 'ch-docker2tar mpibench-mpich' {
    scope full
    need_docker
    TARBALL="$TARDIR/mpibench-mpich.tar.gz"
    ch-docker2tar mpibench-mpich "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build mpibench' {
    scope full
    need_docker mpibench
    ch-build -t mpibench --file="../examples/mpi/mpibench/Dockerfile" ..
    sudo docker tag mpibench "mpibench:$CH_VERSION_DOCKER"
    docker_ok mpibench
}
@test 'ch-docker2tar mpibench' {
    scope full
    need_docker
    TARBALL="$TARDIR/mpibench.tar.gz"
    ch-docker2tar mpibench "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build mpihello-mpich' {
    scope full
    need_docker mpihello-mpich
    ch-build -t mpihello-mpich --file="../examples/mpi/mpihello-mpich/Dockerfile" ..
    sudo docker tag mpihello-mpich "mpihello-mpich:$CH_VERSION_DOCKER"
    docker_ok mpihello-mpich
}
@test 'ch-docker2tar mpihello-mpich' {
    scope full
    need_docker
    TARBALL="$TARDIR/mpihello-mpich.tar.gz"
    ch-docker2tar mpihello-mpich "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build mpihello' {
    scope full
    need_docker mpihello
    ch-build -t mpihello --file="../examples/mpi/mpihello/Dockerfile" ..
    sudo docker tag mpihello "mpihello:$CH_VERSION_DOCKER"
    docker_ok mpihello
}
@test 'ch-docker2tar mpihello' {
    scope full
    need_docker
    TARBALL="$TARDIR/mpihello.tar.gz"
    ch-docker2tar mpihello "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build paraview' {
    scope full
    need_docker paraview
    ch-build -t paraview --file="../examples/mpi/paraview/Dockerfile" ..
    sudo docker tag paraview "paraview:$CH_VERSION_DOCKER"
    docker_ok paraview
}
@test 'ch-docker2tar paraview' {
    scope full
    need_docker
    TARBALL="$TARDIR/paraview.tar.gz"
    ch-docker2tar paraview "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build spark' {
    scope standard
    need_docker spark
    ch-build -t spark --file="../examples/other/spark/Dockerfile" ..
    sudo docker tag spark "spark:$CH_VERSION_DOCKER"
    docker_ok spark
}
@test 'ch-docker2tar spark' {
    scope standard
    need_docker
    TARBALL="$TARDIR/spark.tar.gz"
    ch-docker2tar spark "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build hello' {
    scope standard
    need_docker hello
    ch-build -t hello --file="../examples/serial/hello/Dockerfile" ..
    sudo docker tag hello "hello:$CH_VERSION_DOCKER"
    docker_ok hello
}
@test 'ch-docker2tar hello' {
    scope standard
    need_docker
    TARBALL="$TARDIR/hello.tar.gz"
    ch-docker2tar hello "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build obspy' {
    scope skip
    need_docker obspy
    ch-build -t obspy --file="../examples/serial/obspy/Dockerfile" ..
    sudo docker tag obspy "obspy:$CH_VERSION_DOCKER"
    docker_ok obspy
}
@test 'ch-docker2tar obspy' {
    scope skip
    need_docker
    TARBALL="$TARDIR/obspy.tar.gz"
    ch-docker2tar obspy "$TARDIR"
    tarball_ok "$TARBALL"
}

@test 'ch-build spack' {
    scope full
    need_docker spack
    ch-build -t spack --file="../examples/serial/spack/Dockerfile" ..
    sudo docker tag spack "spack:$CH_VERSION_DOCKER"
    docker_ok spack
}
@test 'ch-docker2tar spack' {
    scope full
    need_docker
    TARBALL="$TARDIR/spack.tar.gz"
    ch-docker2tar spack "$TARDIR"
    tarball_ok "$TARBALL"
}
